#include <bits/stdc++.h>

using namespace std;

int main(){
    ios_base::sync_with_stdio(false);
    cin.tie(0); cout.tie(0);
    int n, q;
    string s;
    cin>>n>>q;
    cin>>s;
    vector <int> six (n+1);
    vector <int> seven (n+1);
    vector <int> dp67 (n);
    for(int i=0; i<n; i++){
        six[i+1]=six[i];
        seven[i+1]=seven[i];
        if(s[i]=='6')
            six[i+1]++;
        else if(s[i]=='7')
            seven[i+1]++;
    }
    int ss=0;
    dp67[0]=0;
    if(s[0]=='6')
        ss++;
    for(int i=1; i<n; i++){
        if(s[i]=='7'){
            dp67[i]=dp67[i-1]+ss;
        }
        else if(s[i]=='6'){
            ss++;
            dp67[i]=dp67[i-1];
        }
        else{

        }

    }
    int a, b;
    for(int i=0; i<q; i++){
        cin>>a>>b;
        cout<<dp67[b-1]-dp67[a-1]-(six[a-1]*(seven[b]-seven[a]))<<endl;
    }
//    for(int el: dp67)
//        cout<<el<<" ";
//    cout<<endl;
//    for(int el: seven)
//        cout<<el<<" ";
//    cout<<endl;
}